diff a/test/hotspot/jtreg/compiler/valhalla/inlinetypes/libTestJNICalls.c b/test/hotspot/jtreg/compiler/valhalla/inlinetypes/libTestJNICalls.c
--- /dev/null
+++ b/test/hotspot/jtreg/compiler/valhalla/inlinetypes/libTestJNICalls.c
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2019, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+#include <jni.h>
+
+JNIEXPORT jobject JNICALL
+Java_compiler_valhalla_inlinetypes_TestJNICalls_testMethod1(JNIEnv *env, jobject receiver, jobject vt) {
+    jclass cls = (*env)->GetObjectClass(env, receiver);
+    jmethodID mid = (*env)->GetMethodID(env, cls, "test1", "(Lcompiler/valhalla/inlinetypes/MyValue1;Z)Lcompiler/valhalla/inlinetypes/MyValue1;");
+    return (*env)->CallObjectMethod(env, receiver, mid, vt, JNI_TRUE);
+}
+
+JNIEXPORT jlong JNICALL
+Java_compiler_valhalla_inlinetypes_TestJNICalls_testMethod2(JNIEnv *env, jobject receiver, jobject vt) {
+    jclass cls = (*env)->GetObjectClass(env, vt);
+    jmethodID mid = (*env)->GetMethodID(env, cls, "hash", "()J");
+    return (*env)->CallLongMethod(env, vt, mid);
+}
+
+JNIEXPORT jint JNICALL
+Java_compiler_valhalla_inlinetypes_TestJNICalls_00024MyValueWithNative_testMethod3(JNIEnv *env, jobject receiver) {
+    jclass cls = (*env)->GetObjectClass(env, receiver);
+    jfieldID fid = (*env)->GetFieldID(env, cls, "x", "I");
+    return (*env)->GetIntField(env, receiver, fid);
+}
